## unicorn-engine 2.1.4

=== CMakeLists.txt ===
# CMake setup for Unicorn 2.
# By Huitao Chen & Nguyen Anh Quynh, 2019-2020

cmake_minimum_required(VERSION 3.5...3.20)

# Only required for MSVC, but we can't know the compiler at this point because we haven't
# called enable_language() or project(), and if we did that it would lock in the old
# policy. Setting these policies is harmless for non-MSVC though, so just enable them
# always.
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    # Set explicitly the policies we want rather than raising the base to the current
    # version. This prevents unintended behavior changes as CMake evolves and provides a
    # consistent experience across different CMake versions.
    # CMP0091: prevent msvcrt flags being added to default CMAKE_<LANG>_FLAGS_<CONFIG>
    cmake_policy(SET CMP0091 NEW)
    # CMP0092: prevent warning flags being added to default CMAKE_<LANG>_FLAGS for MSVC
    cmake_policy(SET CMP0092 NEW)
endif()

# Honor visibility properties for all target types.
cmake_policy(SET CMP0063 NEW)

option(ZIG_BUILD "Enable zig build" OFF)
if(ZIG_BUILD)
    include(cmake/zig.cmake)
endif()

# Workaround to fix wrong compiler on macos.
if(APPLE AND NOT CMAKE_C_COMPILER)
    set(CMAKE_C_COMPILER "/usr/bin/cc")
endif()

# Source: https://github.com/capstone-engine/capstone/blob/next/CMakeLists.txt
# If building for OSX it's best to allow CMake to handle building both architectures
if(APPLE)
    # The cibuildwheel on Github Actions sets this env variable
    # with the architecture flags it wants to build for.
    if(DEFINED ENV{ARCHFLAGS})
        if("$ENV{ARCHFLAGS}" STREQUAL "-arch arm64 -arch x86_64")
            set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
        elseif("$ENV{ARCHFLAGS}" STREQUAL "-arch arm64")
            set(CMAKE_OSX_ARCHITECTURES "arm64")
        elseif("$ENV{ARCHFLAGS}" STREQUAL "-arch x86_64")
            set(CMAKE_OSX_ARCHITECTURES "x86_64")
        endif()
    else()
        set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
    endif()
endif()

# Detect if unicorn is compiled as the top-level project
set(PROJECT_IS_TOP_LEVEL OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(PROJECT_IS_TOP_LEVEL ON)

    # Enable folder support
    set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif()

project(unicorn C)

# We depend on the availability of the CMAKE_MSVC_RUNTIME_LIBRARY, which is only
# available in CMake 3.15 and above (see also the comments above in regards to policy
# CMP0091).
if(MSVC AND CMAKE_VERSION VERSION_LESS "3.15")
    message(FATAL_ERROR "Please update CMake to 3.15 or greater.")
endif()

# mainline qemu mostly just uses compiler default
set(CMAKE_C_STANDARD 11)

set(UNICORN_VERSION_MAJOR 2)
set(UNICORN_VERSION_MINOR 1)
set(UNICORN_VERSION_PATCH 4)

include(cmake/bundle_static.cmake)

# Even though we generate shared lib and static archive at the same time, we still support
# using unicorn as a subdirectory so we have to respect BUILD_SHARED_LIBS.
#
# Also we would like users to link a native cmake target, instead of a custom target for better
# compatability.
option(BUILD_SHARED_LIBS "Build shared instead of static library" ${PROJECT_IS_TOP_LEVEL})
option(UNICORN_LEGACY_STATIC_ARCHIVE "Enable Unicorn v1 style all-in-one objects archive for libunicorn.a" ${PROJECT_IS_TOP_LEVEL})
option(UNICORN_FUZZ "Enable fuzzing" OFF)
option(UNICORN_LOGGING "Enable logging" OFF)
option(UNICORN_BUILD_TESTS "Build unicorn tests" ${PROJECT_IS_TOP_LEVEL})
option(UNICORN_INSTALL "Enable unicorn installation" ${PROJECT_IS_TOP_LEVEL})
set(UNICORN_ARCH "x86;arm;aarch64;riscv;mips;sparc;m68k;ppc;s390x;tricore" CACHE STRING "Enabled unicorn architectures")
option(UNICORN_TRACER "Trace unicorn execution" OFF)

foreach(ARCH_LOOP ${UNICORN_ARCH})
    string(TOUPPER "${ARCH_LOOP}" ARCH_LOOP)
    set(UNICORN_HAS_${ARCH_LOOP} TRUE)
endforeach()

if(MSVC)
    include_directories(
        ${CMAKE_CURRENT_SOURCE_DIR}/msvc
    )
else()
    include_directories(
        ${CMAKE_BINARY_DIR}
    )
endif()

include_directories(
    glib_compat
    qemu
    qemu/include
    include
    qemu/tcg
)

# QEMU logging facility
if (UNICORN_LOGGING)
    add_compile_options(-DUNICORN_LOGGING)
endif()

# Some distributions on some rare architecures don't auto link atomic for us and
# we do this manually by adding flags.
set(ATOMIC_LINKAGE_FIX FALSE)
if(MSVC)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(MSVC_FLAG  -D__x86_64__)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(MSVC_FLAG  -D__i386__)
    else()
        message(FATAL_ERROR "Neither WIN64 or WIN32!")
    endif()

    add_compile_options(
        -Dinline=__inline
        -D__func__=__FUNCTION__
        -D_CRT_SECURE_NO_WARNINGS
        -DWIN32_LEAN_AND_MEAN
        ${MSVC_FLAG}
        /I${CMAKE_CURRENT_SOURCE_DIR}/qemu/tcg/i386
    )

    # Disable some warnings
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4018>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4098>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4244>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4267>)

    # handle msvcrt setting being passed in CMAKE_C_FLAGS
    if(CMAKE_C_FLAGS MATCHES "[/-]M[TD]d?")
        # ensure CMAKE_MSVC_RUNTIME_LIBRARY is not already defined
        if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
            message(FATAL_ERROR "please set the runtime library via either CMAKE_C_FLAGS or CMAKE_MSVC_RUNTIME_LIBRARY, not both")
        endif()

        if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
        elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
        elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
        elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
        endif()

        # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
        string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
    endif()
else()
    if(MINGW)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpmachine
            OUTPUT_VARIABLE UC_COMPILER_VERSION)

        if(UC_COMPILER_VERSION MATCHES "^i686.*")
            set(UNICORN_TARGET_ARCH "i386")
            set(UNICORN_CFLAGS -m32 -static-libgcc) # Workaround for github action bugs
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m32")
        elseif(UC_COMPILER_VERSION MATCHES "^x86_64.*")
            set(UNICORN_TARGET_ARCH "i386")
            set(UNICORN_CFLAGS -m64 -mcx16)
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m64")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
        elseif(UC_COMPILER_VERSION MATCHES "^aarch64.*")
            set(UNICORN_TARGET_ARCH "aarch64")
        endif()
    elseif(ANDROID_ABI)
        string(FIND "${ANDROID_ABI}" "arm64" UC_RET)
        file(WRITE ${CMAKE_BINARY_DIR}/adb.sh "#!/bin/bash\n\n# Auto-generated by CMakeLists.txt\n\nadb shell mkdir -p /data/local/tmp/build\n")

        if(${UC_RET} GREATER_EQUAL "0")
            set(UNICORN_TARGET_ARCH "aarch64")
        else()
            string(FIND "${ANDROID_ABI}" "armeabi" UC_RET)

            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "arm")
            else()
                set(UNICORN_TARGET_ARCH "i386")
            endif()
        endif()
    else()
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dM -E -
            INPUT_FILE /dev/null
            OUTPUT_VARIABLE UC_COMPILER_MACRO)

        while(TRUE)
            string(FIND "${UC_COMPILER_MACRO}" "__x86_64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "i386")
                string(FIND "${UC_COMPILER_MACRO}" "__ILP32__" UC_RET)
                if(${UC_RET} GREATER_EQUAL "0")
                    set(UNICORN_CFLAGS -mx32)
                    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mx32")
                    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -mx32")
                else()
                    set(UNICORN_CFLAGS -m64 -mcx16)
                    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m64")
                    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
                endif()
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__i386__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "i386")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__arm__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "arm")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__aarch64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "aarch64")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__mips__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "mips")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__sparc__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "sparc")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__ia64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "ia64")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "_ARCH_PPC" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "ppc")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__riscv" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "riscv")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__s390__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "s390")
                set(ATOMIC_LINKAGE_FIX TRUE)
                break()
            endif()
            string(FIND ${UC_COMPILER_MACRO} "__tricore__" UC_RET)
            if (${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "tricore")
                break()
            endif()
            string(FIND ${UC_COMPILER_MACRO} "loongarch64" UC_RET)
            if (${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "loongarch64")
                break()
            endif()
            message(FATAL_ERROR "Unknown host compiler: ${CMAKE_C_COMPILER}.")
        endwhile(TRUE)
    endif()

    set(EXTRA_CFLAGS "--extra-cflags=")
    if(UNICORN_HAS_X86)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_X86 ")
    endif()
    if(UNICORN_HAS_ARM)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_ARM ")
    endif()
    if(UNICORN_HAS_AARCH64)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_ARM64 ")
    endif()
    if(UNICORN_HAS_M68K)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_M68K ")
    endif()
    if(UNICORN_HAS_MIPS)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_MIPS -DUNICORN_HAS_MIPSEL -DUNICORN_HAS_MIPS64 -DUNICORN_HAS_MIPS64EL ")
    endif()
    if(UNICORN_HAS_SPARC)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_SPARC ")
    endif()
    if(UNICORN_HAS_PPC)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_PPC ")
    endif()
    if(UNICORN_HAS_RISCV)

=== bindings/Makefile ===
# Unicorn Engine
# By Nguyen Anh Quynh & Dang Hoang Vu, 2015
DIFF = diff

SAMPLE_SOURCE = $(wildcard ../samples/*.c)
SAMPLE = $(SAMPLE_SOURCE:../samples/%.c=%)
SAMPLE := $(SAMPLE:mem_apis=)
SAMPLE := $(SAMPLE:sample_batch_reg=)
SAMPLE := $(SAMPLE:sample_x86_32_gdt_and_seg_regs=)
SAMPLE := $(SAMPLE:shellcode=)

UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S), Linux)
ENV_VARS = LD_PRELOAD=librt.so LD_LIBRARY_PATH=../ DYLD_LIBRARY_PATH=../
else
ENV_VARS = LD_LIBRARY_PATH=../ DYLD_LIBRARY_PATH=../ LIBUNICORN_PATH=$(TRAVIS_BUILD_DIR)
endif


.PHONY: build install python c clean check test

build:
	$(MAKE) -C python gen_const
	$(MAKE) -C go gen_const
	$(MAKE) -C java gen_const
	$(MAKE) -C ruby gen_const
	python3 const_generator.py dotnet
	python3 const_generator.py pascal
	python3 const_generator.py zig

install: build
	$(MAKE) -C python install
	$(MAKE) -C java install

test: $(SAMPLE:%=%.py.test)

c:
	$(MAKE) -C ../samples
python:
	$(MAKE) -C python
%.c.txt: c
	$(ENV_VARS) ../samples/$(@:%.c.txt=%) > $@
%.py.txt: python
	$(ENV_VARS) python3 python/$(@:%.txt=%) > $@

%.py.test: %.c.txt %.py.txt
	$(DIFF) -u $(@:%.py.test=%.c.txt) $(@:%.py.test=%.py.txt)

clean:
#	rm -rf *.txt
	$(MAKE) -C python clean
	$(MAKE) -C java clean

check:
	make -C python check

=== samples/Makefile ===
# Unicorn Engine
# By Nguyen Anh Quynh <aquynh@gmail.com>, 2015

include ../config.mk

UNAME_S := $(shell uname -s)

LIBDIR = ..
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../include

LDFLAGS += -L$(LIBDIR) -lunicorn -lpthread -lm
ifeq ($(UNAME_S), Linux)
LDFLAGS += -lrt
endif

LDLIBS += -lpthread -lunicorn -lm

ifneq ($(CROSS),)
CC = $(CROSS)gcc
endif

ifeq ($(UNICORN_ASAN),yes)
CC = clang 
CXX = clang++
AR = llvm-ar
CFLAGS += -fsanitize=address -fno-omit-frame-pointer
LDFLAGS := -fsanitize=address ${LDFLAGS}
endif

# Cygwin?
ifneq ($(filter CYGWIN%,$(UNAME_S)),)
CFLAGS := $(CFLAGS:-fPIC=)
LDLIBS += -lssp
BIN_EXT = .exe
AR_EXT = a
# mingw?
else ifneq ($(filter MINGW%,$(UNAME_S)),)
CFLAGS := $(CFLAGS:-fPIC=)
BIN_EXT = .exe
AR_EXT = a
endif

ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
ARCHIVE = $(LIBDIR)/unicorn.$(AR_EXT)
else ifneq ($(filter CYGWIN%,$(UNAME_S)),)
ARCHIVE = $(LIBDIR)/libunicorn.$(AR_EXT)
else
ARCHIVE = $(LIBDIR)/libunicorn.$(AR_EXT)
endif
endif

.PHONY: all clean

UNICORN_ARCHS := $(shell if [ -e ../config.log ]; then cat ../config.log;\
				 else printf "$(UNICORN_ARCHS)"; fi)

SOURCES =
ifneq (,$(findstring arm,$(UNICORN_ARCHS)))
SOURCES += sample_arm.c
SOURCES += sample_armeb.c
endif
ifneq (,$(findstring aarch64,$(UNICORN_ARCHS)))
SOURCES += sample_arm64.c
SOURCES += sample_arm64eb.c
endif
ifneq (,$(findstring mips,$(UNICORN_ARCHS)))
SOURCES += sample_mips.c
endif
#ifneq (,$(findstring ppc,$(UNICORN_ARCHS)))
#SOURCES += sample_ppc.c
#endif
ifneq (,$(findstring sparc,$(UNICORN_ARCHS)))
SOURCES += sample_sparc.c
endif
ifneq (,$(findstring x86,$(UNICORN_ARCHS)))
SOURCES += sample_x86.c
SOURCES += shellcode.c
SOURCES += mem_apis.c
SOURCES += sample_x86_32_gdt_and_seg_regs.c
SOURCES += sample_batch_reg.c
SOURCES += sample_mmu.c
endif
ifneq (,$(findstring m68k,$(UNICORN_ARCHS)))
SOURCES += sample_m68k.c
endif
ifneq (,$(findstring tricore,$(UNICORN_ARCHS)))
SOURCES += sample_tricore.c
endif

BINS = $(SOURCES:.c=$(BIN_EXT))
OBJS = $(SOURCES:.c=.o)

all: $(BINS)

$(BINS): $(OBJS)

clean:		
	rm -rf *.o $(BINS)

%$(BIN_EXT): %.o
	@mkdir -p $(@D)
ifeq ($(V),0)
ifeq ($(UNICORN_SHARED),yes)
	$(call log,LINK,$(notdir $@))
	@$(link-dynamic)
endif
ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
	$(call log,LINK,$(notdir $(call staticname,$@)))
	@$(link-static)
endif
endif
else
ifeq ($(UNICORN_SHARED),yes)
	$(link-dynamic)
endif
ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
	$(link-static)
endif
endif
endif

%.o: %.c
	@mkdir -p $(@D)
ifeq ($(V),0)
	$(call log,CC,$(@:%=%))
	@$(compile)
else
	$(compile)
endif


define link-dynamic
	$(CC) $< ${CFLAGS} $(LDFLAGS) -o $@
endef


define link-static
	$(CC) $< $(ARCHIVE) ${CFLAGS} $(LDFLAGS) -o $(call staticname,$@)
endef


staticname = $(subst $(BIN_EXT),,$(1)).static$(BIN_EXT)

define log
	@printf "  %-7s %s\n" "$(1)" "$(2)"
endef

define compile
	${CC} ${CFLAGS} -c $< -o $@
endef

=== bindings/go/Makefile ===
# Go binding for Unicorn engine. Ryan Hileman <lunixbochs@gmail.com>

.PHONY: all gen_const test

all: gen_const
	cd unicorn && go build

gen_const:
	cd .. && python3 const_generator.py go

test: all
	cd unicorn && LD_LIBRARY_PATH=../../../ DYLD_LIBRARY_PATH=../../../ go test

=== bindings/java/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

find_package(JNI)

if (JNI_FOUND)
    message (STATUS "JNI_INCLUDE_DIRS=${JNI_INCLUDE_DIRS}")
    message (STATUS "JNI_LIBRARIES=${JNI_LIBRARIES}")
else()
message(FATAL_ERROR "JNI not found, please try to update JAVA_HOME accordingly")
endif()

add_library(unicorn_java SHARED unicorn_Unicorn.c)

message("${CMAKE_CURRENT_SOURCE_DIR}/bindings/java/target/headers")

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/target/headers")
    message(FATAL_ERROR "bindings/java/target/headers not generated, please generate them firstly")
endif()

target_include_directories(unicorn_java PRIVATE target/headers ${JNI_INCLUDE_DIRS})
target_link_libraries(unicorn_java PRIVATE unicorn ${JNI_LIBRARIES})

=== bindings/java/Makefile ===
# Makefile for the native JNI library. Automatically called by Maven.

JAVA_HOME ?= $(shell java -XshowSettings:properties -version 2>&1 | sed -n 's/ *java.home = //p')

ifeq ($(JAVA_HOME),)
  $(error JAVA_HOME could not be determined; please set it manually (make JAVA_HOME=...))
endif

JAVA_INC := $(JAVA_HOME)/include
JAVA_PLATFORM_INC := $(shell dirname `find $(JAVA_INC) -name jni_md.h`)
UNICORN_INC := ../../include

OS := $(shell uname)
ifeq ($(OS),Darwin)
   LIB_EXT=.dylib
else ifeq ($(OS),Linux)
   LIB_EXT=.so
else
   LIB_EXT=.dll
endif

all: libunicorn_java$(LIB_EXT)

CC=gcc
CFLAGS=-fPIC
LDFLAGS=-shared -fPIC
# May also use -lunicorn to dynamically link against the installed unicorn
LIBS=../../build/libunicorn.a
INCS=-I target/headers -I$(JAVA_INC) -I$(JAVA_PLATFORM_INC) -I$(UNICORN_INC)

OBJS=unicorn_Unicorn.o

unicorn_Unicorn.o: unicorn_Unicorn.c target/headers/unicorn_Unicorn.h
	$(CC) -O2 -Wall -Wextra -Wno-unused-parameter -c $(CFLAGS) $(INCS) $< -o $@

libunicorn_java$(LIB_EXT): $(OBJS)
	$(CC) -o $@ $(LDFLAGS) $(OBJS) $(LIBS)

gen_const:
	cd .. && python3 const_generator.py java

clean:
	rm -f libunicorn_java$(LIB_EXT)
	rm -f $(OBJS)

.PHONY: all clean

=== bindings/python/Makefile ===
# Python binding for Unicorn engine. Nguyen Anh Quynh <aquynh@gmail.com>

.PHONY: gen_const install install3 clean sdist sdist3 bdist bdist3 sdist_win bdist_win

gen_const:
	cd .. && python3 const_generator.py python

install:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	if test -n "${DESTDIR}"; then \
		python3 setup.py install --root="${DESTDIR}"; \
	else \
		python3 setup.py install; \
	fi

install3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	if test -n "${DESTDIR}"; then \
		python3 setup.py install --root="${DESTDIR}"; \
	else \
		python3 setup.py install; \
	fi

# build & upload PyPi package with source code of the core
sdist:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py sdist register upload

# build & upload PyPi package with source code of the core
sdist3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py sdist register upload

# build & upload PyPi package with precompiled core
bdist:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py bdist_wheel register upload

# build & upload PyPi package with precompiled core
bdist3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py bdist_wheel register upload

# build & upload PyPi package with prebuilt core
# NOTE: be sure to have precompiled core under prebuilt/win*/ beforehand
sdist_win:
	rm -rf src/ dist/
	python3 setup.py sdist register upload

# build & upload PyPi package with prebuilt core
# NOTE: be sure to have precompiled core under prebuilt/win*/ beforehand
sdist3_win:
	rm -rf src/ dist/
	python3 setup.py sdist register upload

clean:
	rm -rf src/ dist/ build/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	rm -rf unicorn/lib unicorn/include
	rm -rf unicorn/*.pyc
	rm -rf unicorn.egg-info


SAMPLES = sample_arm.py sample_arm64.py sample_mips.py
SAMPLES += sample_sparc.py sample_m68k.py sample_x86.py
check:
	@for t in $(SAMPLES); do \
		echo Check $$t ... ; \
		./$$t > /dev/null && echo OK || echo FAILED; \
	done

=== bindings/ruby/Makefile ===
# Ruby binding for Unicorn engine. Sascha Schirra <sashs@scoding.de>

.PHONY: gen_const

# Use bundle install && rake to install gem and test
install: gen_const
	cd unicorn_gem && rake build
	cd unicorn_gem && gem install --local pkg/unicorn-engine-2.1.4.gem

gen_const:
	cd .. && python3 const_generator.py ruby

=== tests/fuzz/Makefile ===
CFLAGS += -L ../../ -I ../../include

UNAME_S := $(shell uname -s)
LDFLAGS += -pthread
ifeq ($(UNAME_S), Linux)
LDFLAGS += -lrt
endif

LDFLAGS += ../../libunicorn.a


ALL_TESTS_SOURCES = $(wildcard fuzz*.c)
ALL_TESTS = $(ALL_TESTS_SOURCES:%.c=%)

.PHONY: all
all: ${ALL_TESTS}

.PHONY: clean
clean:
	rm -rf ${ALL_TESTS}

fuzz%: fuzz%.c
	$(CC) $(CFLAGS) $^ onedir.c $(LDFLAGS) -o $@

=== tests/benchmarks/cow/Makefile ===
CFLAGS += -Wall -Werror -I../../../include
CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
LDLIBS += -L../../../build -lgsl -lgslcblas -lm -lunicorn

UNAME_S := $(shell uname -s)
LDLIBS += -pthread
ifeq ($(UNAME_S), Linux)
LDLIBS += -lrt
endif

#EXECUTE_VARS = LD_LIBRARY_PATH=../../cmocka/src:../../build/ DYLD_LIBRARY_PATH=../../build/
EXECUTE_VARS = LD_LIBRARY_PATH=../../../build/cmocka/src:../../../build/ DYLD_LIBRARY_PATH=../../../build/

TESTS_SOURCE = $(wildcard *.c)
TESTS = $(TESTS_SOURCE:%.c=%)

.PHONY: all clean test

test: $(TESTS)

all: $(TESTS)

clean:
	rm -f $(TESTS)

=== debian/changelog ===
unicorn-engine (2.1.4-3) unstable; urgency=medium

  * Ignore broken arm/arm64 memhook counter on riscv64 and mips64el

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Oct 2025 14:02:56 +0200

unicorn-engine (2.1.4-2) unstable; urgency=medium

  * Fix test failures on various architectures

 -- Timo Röhling <roehling@debian.org>  Wed, 15 Oct 2025 23:45:14 +0200

unicorn-engine (2.1.4-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 2.1.4
    - Added loongarch64 support (Closes: #1104201)
  * Update patches.
    - Obsolete: 0004-Skip-broken-armhf-test.patch
    - Obsolete: 0005-Fix-FTBFS-in-ruby-gem.patch
    - Obsolete: 0006-Fix-big-endian-issues.patch
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Prevent second library build for Python module
  * Do not install unicorn.o
  * Run pybuild autopkgtest
  * Migrate to PEP 517 build

 -- Timo Röhling <roehling@debian.org>  Thu, 18 Sep 2025 16:40:42 +0200

=== debian/control ===
Source: unicorn-engine
Section: libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-ruby,
 dpkg-dev (>= 1.22.5),
 cmake,
 gem2deb,
 pkgconf,
 rake,
 ruby-magic:native,
Build-Depends-Indep:
 dh-python,
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-capstone <!nocheck>,
 python3-pytest <!nocheck>,
 python3-setuptools,
Homepage: https://unicorn-engine.org
Standards-Version: 4.7.2
XS-Ruby-Versions: all
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/unicorn-engine.git
Vcs-Browser: https://salsa.debian.org/roehling/unicorn-engine
Testsuite: autopkgtest-pkg-pybuild
Description: Lightweight CPU emulator framework
 Unicorn is a CPU emulator which is based on the CPU emulation code from
 QEMU. Unlike QEMU, it focuses on the emulation of CPU code without a
 full system emulation, but with the goal to make the emulation
 extensible and easy to integrate in custom tools. Unicorn provides
 language bindings for Python, Ruby, and Rust (among others) and has
 instrumentation hooks for various CPU events. This makes Unicorn well
 suited for malware analysis and reverse engineering.

Package: libunicorn2t64
Provides:
 ${t64:Provides},
Replaces:
 libunicorn2,
Breaks:
 libunicorn2 (<< ${source:Version}),
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs the shared library of Unicorn.

Package: libunicorn-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libunicorn2t64 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (development headers)
 ${source:Extended-Description}
 .
 This package installs the headers and development files.

Package: python3-unicorn
Section: python
Architecture: all
Depends:
 libunicorn2t64 (>= ${source:Upstream-Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: ${source:Synopsis} (Python 3 bindings)
 ${source:Extended-Description}
 .
 This package installs the Python 3 bindings.

Package: ruby-unicorn-engine
Section: ruby
Architecture: any
Multi-Arch: same
XB-Ruby-Versions: ${ruby:Versions}
X-DhRuby-Root: bindings/ruby/unicorn_gem
Depends:
 ${misc:Depends},
 ${ruby:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (Ruby bindings)
 ${source:Extended-Description}
 .
 This package installs the Ruby bindings.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME = unicorn
export PYBUILD_TEST_ARGS = --ignore=tests/test_network_auditing.py --ignore=tests/test_shellcode.py
export DH_RUBY = --gem-install
export LIBUNICORN_PATH = /anything/to/prevent/duplicate/build

%:
	dh $@ --buildsystem=cmake

ifeq ($(PYBUILD_AUTOPKGTEST),1)
override_dh_auto_test:
	dh_auto_test --buildsystem=pybuild --sourcedirectory=bindings/python 
else
ifneq ($(filter mips64el riscv64,$(DEB_HOST_ARCH)),)
override_dh_auto_test:
	-dh_auto_test --buildsystem=cmake
endif
endif

execute_after_dh_auto_clean-arch \
execute_after_dh_auto_configure-arch \
execute_after_dh_auto_build-arch \
execute_after_dh_auto_install-arch: execute_after_%-arch:
	CPATH=$(CURDIR)/include \
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=ruby

execute_after_dh_auto_configure-indep \
execute_after_dh_auto_build-indep \
execute_after_dh_auto_test-indep \
execute_after_dh_auto_install-indep: execute_after_%-indep:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=pybuild --sourcedirectory=bindings/python

=== debian/watch ===
Version: 5

Template: Github
Owner: unicorn-engine
Project: unicorn
Dversion-Mangle: auto
Uversion-Mangle: auto
